SortGroupInformation = {};
local L = LibStub("AceLocale-3.0"):GetLocale("SortGroup")
CompactSave = {}

local frame = {};
frame = CreateFrame("Frame", "SortGroupPanel", UIParent);
local framePage2 = CreateFrame("Frame", "SortGroupPanelPage2", frame);
-- Main Frame

GroupTop = false;
GroupBottom = false;
GroupTopDownwards = false;
GroupTopUpwards = false;
GroupBottomDownwards = false;
GroupBottomUpwards = false;
RegardlessRaidProfile = false;
GroupAutoActivate = false;
raidProfile = nil;
chatMessagesOn = true;
cacheAutoActive = nil;

page2Active = false;
page2raidProfile = nil;
page2raidProfileSaved = nil;
page2ddmSavedProfilesCounter = 0;
page2RaidProfilesOnLoad = {};
page2Array = {}
page2raidProfilOnThatPlace = "";
-- cacheAutoActive intern cache for AutoActivate
-- page2ddmSavedProfiles count, necessary for deleting
-- page2raidProfilOnThatPlace, changeOwnElemnt = false -> RaidProfile
-- Chosen Options

showChatMessage = false;
-- true when "PLAYER_ENTERING_WORLD" fired or cb Event gets triggerd

inCombat = false;
-- true when "PLAYER_REGEN_DISABLED" fired

debugmode = false;
debuglevel = 4;
-- debuging, false = deactivated
-- 1 Options
-- 2 Events+Method Names
-- 4 Methods content
-- combinable

debugLevelCache = nil;
debugMethodNameCache = nil;
debugMethodContentCache = nil;
-- Intern cache, to display everything better

raidProfilOnLoadIndex = 0;

local manager = CompactRaidFrameManager;

local cBTop = CreateFrame("CheckButton", "CheckButtonTop_Text", frame, "UICheckButtonTemplate");
local cBBottom = CreateFrame("CheckButton", "CheckButtonBottom_Text", frame, "UICheckButtonTemplate");
local cbTopDownwards = CreateFrame("CheckButton", "CheckButtonTopDownwards_Text", frame, "UICheckButtonTemplate");
local cbTopUpwards = CreateFrame("CheckButton", "CheckButtonTopUpwards_Text", frame, "UICheckButtonTemplate");
local cbBottomDownwards = CreateFrame("CheckButton", "CheckButtonBottomDownwards_Text", frame, "UICheckButtonTemplate");
local cbBottomUpwards = CreateFrame("CheckButton", "CheckButtonBottomUpwards_Text", frame, "UICheckButtonTemplate");
local cbAutoActivate = CreateFrame("CheckButton", "CheckButtonAutoActivate_Text", frame, "UICheckButtonTemplate");
local cbRegardlessRaidProfile = CreateFrame("CheckButton", "CheckButtonRegardlessRaidProfile_Text", frame, "UICheckButtonTemplate");
local cbChatMessagesOn = CreateFrame("CheckButton", "CheckButtonChatMessagesOn_Text", frame, "UICheckButtonTemplate");

local page2cbActive = CreateFrame("CheckButton", "CheckButtonPage2Active_Text", framePage2, "UICheckButtonTemplate");
-- Combo-box Options

local btnReload = CreateFrame("Button", "Button_Text", frame, "UIPanelButtonTemplate");
local page2btnSave = CreateFrame("Button", "page2btnSave_Text", framePage2, "UIPanelButtonTemplate");
local page2btnDelete = CreateFrame("Button", "page2btnDelete_Text", framePage2, "UIPanelButtonTemplate");
local page2btnReset = CreateFrame("Button", "page2btnReset_Text", framePage2, "UIPanelButtonTemplate");
-- Button

local ddmProfiles = CreateFrame("Button", "DropDownMenuProfiles", frame, "UIDropDownMenuTemplate");
local page2ddmProfiles = CreateFrame("Button", "DropDownMenuPage2Profiles", framePage2, "UIDropDownMenuTemplate");
local page2ddmSavedProfiles = CreateFrame("Button", "page2ddmSavedProfiles", framePage2, "UIDropDownMenuTemplate");
ddmItems = {};
-- DropDownMenu

local page2SliderMinimum = CreateFrame("Slider", "page2SliderMinimum_Text", framePage2, "OptionsSliderTemplate");
local page2SliderMaximum = CreateFrame("Slider", "page2SliderMaximum_Text", framePage2, "OptionsSliderTemplate");
-- Sliders

local page2TextFrom = CreateFrame("SimpleHTML", "page2TextFrom_Text", framePage2);
local page2TextTo = CreateFrame("SimpleHTML", "page2TextTo_Text", framePage2);

local textVersion = CreateFrame("SimpleHTML", "textVersion_Text", frame);
local textAuthor = CreateFrame("SimpleHTML", "textAuthor_Text", frame);
local version = "2.4.2";
local author = "Collabo93"

local defaultColor = "#FFFFFF";
---End Variables



local function createFrame()	
	frame.name = "SortGroup";
	fontFrame = frame:CreateFontString("SortGroup_Title", "OVERLAY", "GameFontHighlight");
	fontFrame:SetFont("Fonts\\FRIZQT__.TTF", 18);
	fontFrame:SetTextColor(1, 0.8, 0);
    fontFrame:SetPoint("TOPLEFT", 12, -18);
    fontFrame:SetText("SortGroup".."|r");
	frame.okay = function(frame)
		Debug("InterfaceOptionsFrameOkay", "", 2);
		SendSortOptionToSortBy();
	end
	frame.cancel = function(frame)
		if ( inCombat == false ) then
			Debug("InterfaceOptionsFrameCancel", "", 2);
			SendSortOptionToSortBy();
		end
	end
	InterfaceOptions_AddCategory(frame);
	
	framePage2.name = L["framePage2_Name"];
	fontFramePage2 = framePage2:CreateFontString("SortGroup_Title", "OVERLAY", "GameFontHighlight");
	fontFramePage2:SetFont("Fonts\\FRIZQT__.TTF", 18);
	fontFramePage2:SetTextColor(1, 0.8, 0);
    fontFramePage2:SetPoint("TOPLEFT", 12, -18);
    fontFramePage2:SetText(L["framePage2_description"].."|r");
	framePage2.parent = frame.name;
	InterfaceOptions_AddCategory(framePage2);
end

local function createText()
	textVersion:SetSize(200, 20);
	textVersion:SetPoint("TOPLEFT", 13,-45);
	textVersion:SetFontObject(GameFontHighlightSmall);
	textVersion:SetText("|cFF00FF00Version  |r" .. version);
	
	textAuthor:SetSize(200, 20);
	textAuthor:SetPoint("TOPLEFT", 13,-55);
	textAuthor:SetFontObject(GameFontHighlightSmall);
	textAuthor:SetText("|cFF00FF00Author   |r" .. author);
	
	page2TextFrom:SetSize(200, 20);
	page2TextFrom:SetPoint("TOPLEFT", 220,-70);
	page2TextFrom:SetFontObject(GameFontHighlightMedium);
	page2TextFrom:SetText("|cFF00FF00" .. L["page2TextFrom"]);
	
	page2TextTo:SetSize(200, 20);
	page2TextTo:SetPoint("TOPLEFT", 380,-185);
	page2TextTo:SetFontObject(GameFontHighlightMedium);
	page2TextTo:SetText("|cFF00FF00" .. L["page2TextTo"]);
end

local function createCheckbox()		
	cBTop:SetPoint("TOPLEFT", 10, -100);
	cBBottom:SetPoint("TOPLEFT",10, -200);
	cbTopDownwards:SetPoint("TOPLEFT", 40, -130);
	cbTopUpwards:SetPoint("TOPLEFT", 40, -155);
	cbBottomDownwards:SetPoint("TOPLEFT", 40, -230);
	cbBottomUpwards:SetPoint("TOPLEFT", 40, -255);
	cbRegardlessRaidProfile:SetPoint("TOPLEFT",340,-100);
	cbAutoActivate:SetPoint("TOPLEFT",370,-130);
	cbChatMessagesOn:SetPoint("TOPLEFT",500,-35);
	
	getglobal(cBTop:GetName() .. 'Text'):SetText(L["cBTop_Option_Text"]);
	getglobal(cBBottom:GetName() .. 'Text'):SetText(L["cBBottom_Option_Text"]);
	getglobal(cbTopDownwards:GetName() .. 'Text'):SetText(L["cbDownwards_Option_Text"]);
	getglobal(cbTopUpwards:GetName() .. 'Text'):SetText(L["cbUpwards_Option_Text"]);
	getglobal(cbBottomDownwards:GetName() .. 'Text'):SetText(L["cbDownwards_Option_Text"]);
	getglobal(cbBottomUpwards:GetName() .. 'Text'):SetText(L["cbUpwards_Option_Text"]);
	getglobal(cbAutoActivate:GetName() .. 'Text'):SetText(L["cbAutoActivate_Option_Text"]);
	getglobal(cbRegardlessRaidProfile:GetName() .. 'Text'):SetText(L["cbRegardlessRaidProfile_Text"]);
	getglobal(cbChatMessagesOn:GetName() .. 'Text'):SetText(L["cbChatMessagesOn_Text"]);
	
	page2cbActive:SetPoint("TOPLEFT", 10, -60);
	getglobal(page2cbActive:GetName() .. 'Text'):SetText(L["page2cbActive_Text"]);
end

local function createButton()
	btnReload:SetSize(84, 24);
	btnReload:SetText(L["btn_Option_text"]);
	btnReload:SetPoint("TOPLEFT", 10, -350);
	
	page2btnSave:SetSize(120, 24);
	page2btnSave:SetText(L["page2btnSave_text"]);
	page2btnSave:SetPoint("Topleft", 50, -170)
	
	page2btnDelete:SetSize(120, 24);
	page2btnDelete:SetText(L["page2btnDelete_text"]);
	page2btnDelete:SetPoint("Topleft", 450, -170)
	
	page2btnReset:SetSize(120, 24);
	page2btnReset:SetText(L["page2btnReset_text"]);
	page2btnReset:SetPoint("Topleft", 10, -270)
end

local function createDropDownMenu()
	ddmProfiles.text = _G["DropDownMenuProfiles"];
	ddmProfiles.text:SetText("Empty ddm");
	ddmProfiles:SetPoint("TOPLEFT", 360, -160);		
	ddmProfiles.info = {};
	ddmProfiles.initialize = function(self, level)
		if ( inCombat == false and level == 1 ) then
			wipe(self.info);
			ReadAllRaidProfiles();
			for i, value in pairs(ddmItems) do
				self.info.text = value;
				self.info.value = i;
				self.info.func = function(item)
					if ( RaidProfilOnLoadExists(value) == true ) then
						table.remove(page2RaidProfilesOnLoad, raidProfilOnLoadIndex);
					end
					self.selectedID = item:GetID();
					self.text:SetText(item);
					self.value = i;
					raidProfile = value;
					UIDropDownMenu_SetText(ddmProfiles, raidProfile);
					UIDropDownMenu_SetText(page2ddmProfiles, "");
					showChatMessage = true;
					DisableSliders();
					fillArray();
					SendSortOptionToSortBy();
				end
				self.info.checked = i == self.text:GetText();
				UIDropDownMenu_AddButton(self.info, level);
				if ( raidProfile == self.info.text ) then
					UIDropDownMenu_SetSelectedID(ddmProfiles, i);
				end
			end
		else
			if ( chatMessagesOn == true ) then
				print(ColorPrint(L["in_combat_options"], "option"));
			end
		end
	end
	ddmProfiles:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self,"ANCHOR_RIGHT");
			GameTooltip:AddLine(L["ddmProfiles_ToolTip_Text"], nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	ddmProfiles:SetScript("OnLeave", function(self) GameTooltip:Hide() end)	
	
	
	page2ddmProfiles.text = _G["DropDownMenuProfiles"];
	page2ddmProfiles.text:SetText("Empty ddm");
	page2ddmProfiles:SetPoint("TOPLEFT", 25, -120);		
	page2ddmProfiles.info = {};
	page2ddmProfiles.initialize = function(self, level)
		if ( inCombat == false and level == 1 ) then
			wipe(self.info);
			DeleteRaidProfileNotExists();
			ReadAllRaidProfiles();
			for i, value in pairs(ddmItems) do
				if ( RaidProfilOnLoadExists(value) == false ) then
					self.info.text = value;
					self.info.value = i;
					self.info.func = function(item)
						self.selectedID = item:GetID();
						self.text:SetText(item);
						self.value = i;
						page2raidProfile = value;
						UIDropDownMenu_SetText(page2ddmSavedProfiles, "");
						UIDropDownMenu_SetText(page2ddmProfiles, page2raidProfile);					
						page2raidProfileSaved = nil;
						if ( page2raidProfile == raidProfile and GroupAutoActivate == true ) then
							page2SliderMinimum:Disable();
							page2SliderMaximum:Disable();
							page2btnSave:Disable();
							page2btnDelete:Disable();
							page2SliderMinimum_Text:SetMinMaxValues(2, 5);
							page2SliderMaximum_Text:SetMinMaxValues(2, 5);
							page2SliderMinimum_Text:SetValue(2);
							page2SliderMaximum_Text:SetValue(5);									
							getglobal(page2SliderMinimum:GetName() .. 'Low'):SetText(ColorPrint('2', "disable"));
							getglobal(page2SliderMinimum:GetName() .. 'High'):SetText(ColorPrint('5', "disable"));
							getglobal(page2SliderMinimum:GetName() .. 'Text'):SetText(ColorPrint(math.floor(page2SliderMinimum:GetValue()), "disable"));
							getglobal(page2SliderMaximum:GetName() .. 'Low'):SetText(ColorPrint('2', "disable"));
							getglobal(page2SliderMaximum:GetName() .. 'High'):SetText(ColorPrint('5', "disable"))
							getglobal(page2SliderMaximum:GetName() .. 'Text'):SetText(ColorPrint(math.floor(page2SliderMaximum:GetValue()), "disable"));
						else
							page2SliderMinimum:Enable();
							page2SliderMaximum:Enable();
							page2btnSave:Enable();
							if ( GroupAutoActivate == true ) then
								page2SliderMinimum_Text:SetMinMaxValues(6, 40);
								page2SliderMaximum_Text:SetMinMaxValues(6, 40);
								page2SliderMinimum_Text:SetValue(6);
								page2SliderMaximum_Text:SetValue(40);
								getglobal(page2SliderMinimum:GetName() .. 'Low'):SetText('6');
								getglobal(page2SliderMinimum:GetName() .. 'High'):SetText('40');
								getglobal(page2SliderMaximum:GetName() .. 'Low'):SetText('6');
								getglobal(page2SliderMaximum:GetName() .. 'High'):SetText('40')
							else
								page2SliderMinimum_Text:SetMinMaxValues(2, 40);
								page2SliderMaximum_Text:SetMinMaxValues(2, 40);
								page2SliderMinimum_Text:SetValue(2);
								page2SliderMaximum_Text:SetValue(40);
								getglobal(page2SliderMinimum:GetName() .. 'Low'):SetText('2');
								getglobal(page2SliderMinimum:GetName() .. 'High'):SetText('40');
								getglobal(page2SliderMaximum:GetName() .. 'Low'):SetText('2');
								getglobal(page2SliderMaximum:GetName() .. 'High'):SetText('40')						
							end
							ColorSliders("ddmProfiles");
						end
					end
					self.info.checked = i == self.text:GetText();
					UIDropDownMenu_AddButton(self.info, level);
					if ( page2raidProfile == self.info.text ) then
						UIDropDownMenu_SetSelectedID(page2ddmProfiles, i)
					end
				end
			end
		else
			if ( chatMessagesOn == true ) then
				print(ColorPrint(L["in_combat_options"], "option"));
			end
		end
	end
	page2ddmProfiles:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self,"ANCHOR_RIGHT");
			GameTooltip:AddLine(L["page2ddmProfiles_ToolTip_Text"], nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	page2ddmProfiles:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
	
	
	page2ddmSavedProfiles.text = _G["DropDownMenuProfiles"];
	page2ddmSavedProfiles.text:SetText("Empty ddm");
	page2ddmSavedProfiles:SetPoint("TOPLEFT", 425, -120);		
	page2ddmSavedProfiles.info = {};
	page2ddmSavedProfiles.initialize = function(self, level)
		if ( inCombat == false and level == 1 ) then
			wipe(self.info);
			DeleteRaidProfileNotExists()
			page2ddmSavedProfilesCounter = 0;
			for i = 1, (CountTable(page2RaidProfilesOnLoad)), 1 do
				self.info.text = page2RaidProfilesOnLoad[i].RaidProfileName;
				self.info.value = i;
				page2ddmSavedProfilesCounter = page2ddmSavedProfilesCounter + 1;
				self.info.func = function(item)
					self.selectedID = item:GetID();
					self.text:SetText(item);
					self.value = i;
					page2raidProfileSaved = page2RaidProfilesOnLoad[i].RaidProfileName;
					UIDropDownMenu_SetText(page2ddmSavedProfiles, page2raidProfileSaved);
					UIDropDownMenu_SetText(page2ddmProfiles, "");
					page2btnDelete:Enable();
					page2btnSave:Enable();
					page2SliderMinimum:Enable();
					page2SliderMaximum:Enable();
					page2raidProfile = nil;
					if ( GroupAutoActivate == true ) then
						page2SliderMinimum_Text:SetMinMaxValues(6, 40);
						page2SliderMaximum_Text:SetMinMaxValues(6, 40);
						page2SliderMinimum_Text:SetValue(6);
						page2SliderMaximum_Text:SetValue(40);
						getglobal(page2SliderMinimum:GetName() .. 'Low'):SetText('6');
						getglobal(page2SliderMinimum:GetName() .. 'High'):SetText('40');
						getglobal(page2SliderMaximum:GetName() .. 'Low'):SetText('6');
						getglobal(page2SliderMaximum:GetName() .. 'High'):SetText('40')
					else
						page2SliderMinimum_Text:SetMinMaxValues(2, 40);
						page2SliderMaximum_Text:SetMinMaxValues(2, 40);
						getglobal(page2SliderMinimum:GetName() .. 'Low'):SetText('2');
						getglobal(page2SliderMinimum:GetName() .. 'High'):SetText('40');
						getglobal(page2SliderMaximum:GetName() .. 'Low'):SetText('2');
						getglobal(page2SliderMaximum:GetName() .. 'High'):SetText('40')			
					end
					ColorSliders("ddmSelectedProfiles",i);
				end
				self.info.checked = i == self.text:GetText();
				UIDropDownMenu_AddButton(self.info, level);
				if ( page2ddmSavedProfiles == self.info.text ) then
					UIDropDownMenu_SetSelectedID(page2ddmSavedProfiles, i)
				end
			end
		else
			if ( chatMessagesOn == true ) then
				print(ColorPrint(L["in_combat_options"], "option"));
			end
		end
	end
	page2ddmSavedProfiles:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self,"ANCHOR_RIGHT");
			GameTooltip:AddLine(L["page2ddmSelectedProfiles_ToolTip_Text"], nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	page2ddmSavedProfiles:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
end
--DropDownMenu creating, include items

local function createSliders()
	page2SliderMinimum_Text:SetSize(150, 17);
	page2SliderMinimum_Text:SetPoint("TOPLEFT",230,-100);
	page2SliderMinimum_Text:SetOrientation('HORIZONTAL');
	page2SliderMinimum_Text:SetThumbTexture("Interface\\Buttons\\UI-SliderBar-Button-Horizontal");
	page2SliderMinimum_Text:SetMinMaxValues(2,40);
	page2SliderMinimum_Text:SetValue(2);
	getglobal(page2SliderMinimum:GetName() .. 'Low'):SetText('2');
	getglobal(page2SliderMinimum:GetName() .. 'High'):SetText('40');
	getglobal(page2SliderMinimum:GetName() .. 'Text'):SetText(page2SliderMinimum:GetValue());
	page2SliderMinimum_Text:SetBackdrop({
		bgFile = "Interface\\Buttons\\UI-SliderBar-Background", 
		edgeFile = "Interface\\Buttons\\UI-SliderBar-Border",
		tile = true, tileSize = 8, edgeSize = 8, 
		insets = { left = 3, right = 3, top = 6, bottom = 6 }})
	page2SliderMinimum_Text:SetValueStep(1);
	
	page2SliderMaximum_Text:SetSize(150, 17);
	page2SliderMaximum_Text:SetPoint("TOPLEFT", 230,-150);
	page2SliderMaximum_Text:SetOrientation('HORIZONTAL');
	page2SliderMaximum_Text:SetThumbTexture("Interface\\Buttons\\UI-SliderBar-Button-Horizontal");
	page2SliderMaximum_Text:SetMinMaxValues(2,40);
	page2SliderMaximum_Text:SetValue(40);
	getglobal(page2SliderMaximum:GetName() .. 'Low'):SetText('2');
	getglobal(page2SliderMaximum:GetName() .. 'High'):SetText('40');
	getglobal(page2SliderMaximum:GetName() .. 'Text'):SetText(page2SliderMaximum:GetValue());
	page2SliderMaximum_Text:SetBackdrop({
		bgFile = "Interface\\Buttons\\UI-SliderBar-Background", 
		edgeFile = "Interface\\Buttons\\UI-SliderBar-Border",
		tile = true, tileSize = 8, edgeSize = 8, 
		insets = { left = 3, right = 3, top = 6, bottom = 6 }})
	page2SliderMaximum_Text:SetValueStep(1);
end
--- End Creating



local function frameEvent()
	frame:RegisterEvent("COMPACT_UNIT_FRAME_PROFILES_LOADED");
	frame:RegisterEvent("PLAYER_ENTERING_WORLD");
	frame:RegisterEvent("PLAYER_LOGOUT");
	frame:RegisterEvent("PLAYER_REGEN_DISABLED");
	frame:RegisterEvent("PLAYER_REGEN_ENABLED");
	frame:RegisterEvent("GROUP_ROSTER_UPDATE");
	frame:RegisterEvent("PARTY_MEMBERS_CHANGED");
	frame:SetScript("OnEvent", 
		function(self, event, ...)	
			if ( event == "PLAYER_LOGOUT" ) then 
				Debug("PLAYER_LOGOUT", "", 1);
				SaveOptions();
				frame:UnregisterEvent(event);
			elseif ( event == "PLAYER_REGEN_DISABLED" ) then
				Debug("PLAYER_REGEN_DISABLED", "", 1);
				inCombat = true;
			elseif ( event == "PLAYER_REGEN_ENABLED" ) then
				Debug("PLAYER_REGEN_ENABLED", "", 1);
				inCombat = false;
				for k, v in pairs(CompactSave) do
					CompactSave[k] = nil
					_G[v](_G[k])
				end
				SendSortOptionToSortBy();
			elseif ( event == "GROUP_ROSTER_UPDATE" or event == "PARTY_MEMBERS_CHANGED" ) then
				Debug("GROUP_ROSTER_UPDATE", "", 1);
				if ( page2Active == true ) then
					SwitchRaidProfiles();
					if ( SortGroupIsActive() == true ) then
						SendSortOptionToSortBy();
					end
				end
			elseif ( event == "COMPACT_UNIT_FRAME_PROFILES_LOADED" ) then
				Debug("COMPACT_UNIT_FRAME_PROFILES_LOADED", "", 1)
				if ( SortGroupInformation.Down == nil or SortGroupInformation.Up == nil ) then
					SortGroupInformation.Down = true;
					SortGroupInformation.Up = false;
					Debug("COMPACT_UNIT_FRAME_PROFILES_LOADED", "Down/Up = nil - new");
				end	
				if ( SortGroupInformation.TopDownwards == nil or SortGroupInformation.TopUpwards == nil or SortGroupInformation.BottomDownwards == nil or SortGroupInformation.BottomUpwards == nil) then
					if ( SortGroupInformation.Down == true ) then	
						SortGroupInformation.TopDownwards = true;
						SortGroupInformation.TopUpwards	= false;
						SortGroupInformation.BottomDownwards = false;
						SortGroupInformation.BottomUpwards = false;
						Debug("COMPACT_UNIT_FRAME_PROFILES_LOADED", "Down = true, Down/Up - new");
					elseif ( SortGroupInformation.Up == true ) then
						SortGroupInformation.TopDownwards = false;
						SortGroupInformation.TopUpwards	= false;
						SortGroupInformation.BottomDownwards = false;
						SortGroupInformation.BottomUpwards = true;
						Debug("COMPACT_UNIT_FRAME_PROFILES_LOADED", "Up = true, Down/Up - new");
					else
						SortGroupInformation.TopDownwards = false;
						SortGroupInformation.TopUpwards	= false;
						SortGroupInformation.BottomDownwards = false;
						SortGroupInformation.BottomUpwards = false;
						Debug("COMPACT_UNIT_FRAME_PROFILES_LOADED", "Down = false, Up = false - error");
					end
				end
				if ( SortGroupInformation.Profile == nil ) then
					SortGroupInformation.Profile = GetRaidProfileName(1);
					Debug("COMPACT_UNIT_FRAME_PROFILES_LOADED", "SortGroupInformation.Profile = nil - new");
				end				
				if ( SortGroupInformation.AutoActivate == nil ) then
					SortGroupInformation.AutoActivate = true;
					Debug("COMPACT_UNIT_FRAME_PROFILES_LOADED", "SortGroupInformation.AutoActivate = nil - new");
				end				
				if ( SortGroupInformation.RegardlessRaidProfile == nil ) then
					SortGroupInformation.RegardlessRaidProfile = false;
					Debug("COMPACT_UNIT_FRAME_PROFILES_LOADED", "SortGroupInformation.RegardlessRaidProfile = nil - new");
				end		
				if ( SortGroupInformation.chatMessagesOn == nil ) then
					SortGroupInformation.chatMessagesOn = true;
					Debug("COMPACT_UNIT_FRAME_PROFILES_LOADED", "SortGroupInformation.chatMessagesOn = nil - new");
				end
				if ( SortGroupInformation.page2Active == nil ) then
					SortGroupInformation.page2Active = false;
					Debug("COMPACT_UNIT_FRAME_PROFILES_LOADED", "SortGroupInformation.page2Active = nil - new");
				end
				if ( SortGroupInformation.RaidProfileOnLoad == nil ) then
					SortGroupInformation.RaidProfileOnLoad = {};	
					Debug("COMPACT_UNIT_FRAME_PROFILES_LOADED", "SortGroupInformation.RaidProfileOnLoad = nil - new");					
				end
				
				GroupTop = SortGroupInformation.Down;
				GroupBottom = SortGroupInformation.Up;
				GroupTopDownwards = SortGroupInformation.TopDownwards;
				GroupTopUpwards = SortGroupInformation.TopUpwards;
				GroupBottomDownwards = SortGroupInformation.BottomDownwards;
				GroupBottomUpwards = SortGroupInformation.BottomUpwards;
				GroupAutoActivate = SortGroupInformation.AutoActivate;
				RegardlessRaidProfile = SortGroupInformation.RegardlessRaidProfile;
				chatMessagesOn = SortGroupInformation.chatMessagesOn;
				raidProfile = SortGroupInformation.Profile;
				
				page2Active = SortGroupInformation.page2Active;
				page2RaidProfilesOnLoad = SortGroupInformation.RaidProfileOnLoad;
				DeleteRaidProfileNotExists();
				--fillArray();
				
				UIDropDownMenu_SetText(ddmProfiles, raidProfile)
				ChangesComboBoxes();
				--Get informations
				
				showChatMessage = true;
				SendSortOptionToSortBy();		
				-- Start sort
				frame:UnregisterEvent(event);	
			elseif ( event == "PLAYER_ENTERING_WORLD" and HasLoadedCUFProfiles() == true and inCombat == false) then	
				Debug("PLAYER_ENTERING_WORLD", "", 1);		
				showChatMessage = false;
				SendSortOptionToSortBy();
			end
		end);
end

local function checkBoxEvent()
	cBTop:SetScript("OnClick",
		function()
			if ( inCombat == false ) then
				showChatMessage = true;
				if ( cBTop:GetChecked() == true ) then
					GroupTop = true;
					GroupBottom = false;
					cBBottom:SetChecked(false);
					cbTopDownwards:Enable();
					cbTopUpwards:Enable();
					cbBottomDownwards:Disable();
					cbBottomUpwards:Disable();
					getglobal(cbTopDownwards:GetName() .. 'Text'):SetText(L["cbDownwards_Option_Text"]);
					getglobal(cbTopUpwards:GetName() .. 'Text'):SetText(L["cbUpwards_Option_Text"]);
					getglobal(cbBottomDownwards:GetName() .. 'Text'):SetText(ColorPrint(L["cbDownwards_Option_Text"],"disable"));
					getglobal(cbBottomUpwards:GetName() .. 'Text'):SetText(ColorPrint(L["cbUpwards_Option_Text"],"disable"));
				elseif ( cBTop:GetChecked() == false ) then	
					GroupTop = false;
					cbTopDownwards:Disable();
					cbTopUpwards:Disable();
					getglobal(cbTopDownwards:GetName() .. 'Text'):SetText(ColorPrint(L["cbDownwards_Option_Text"],"disable"));
					getglobal(cbTopUpwards:GetName() .. 'Text'):SetText(ColorPrint(L["cbUpwards_Option_Text"],"disable"))
				end
				SaveOptions();
				SendSortOptionToSortBy();
				Debug("checkBoxEvent", "", 1);
			else
				ChangesComboBoxes(true);
				if ( chatMessagesOn == true ) then
					print(ColorPrint(L["in_combat_options"], "option"));
				end
			end
		end);		
	cBTop:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self,"ANCHOR_RIGHT");
			GameTooltip:AddLine(L["cBTop_ToolTip_Text"], nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	cBTop:SetScript("OnLeave", function(self) GameTooltip:Hide() end)	
	--Combobox Top
		
	cBBottom:SetScript("OnClick",
		function()
			if ( inCombat == false ) then
				showChatMessage = true;
				if ( cBBottom:GetChecked() == true ) then
					GroupTop = false;
					GroupBottom = true;
					cBTop:SetChecked(false);
					cbTopDownwards:Disable();
					cbTopUpwards:Disable();
					cbBottomDownwards:Enable();
					cbBottomUpwards:Enable();
					getglobal(cbTopDownwards:GetName() .. 'Text'):SetText(ColorPrint(L["cbDownwards_Option_Text"],"disable"));
					getglobal(cbTopUpwards:GetName() .. 'Text'):SetText(ColorPrint(L["cbUpwards_Option_Text"],"disable"));
					getglobal(cbBottomDownwards:GetName() .. 'Text'):SetText(L["cbDownwards_Option_Text"]);
					getglobal(cbBottomUpwards:GetName() .. 'Text'):SetText(L["cbUpwards_Option_Text"]);
				elseif ( cBBottom:GetChecked() == false ) then	
					GroupBottom = false;
					cbBottomDownwards:Disable();
					cbBottomUpwards:Disable();
					getglobal(cbBottomDownwards:GetName() .. 'Text'):SetText(ColorPrint(L["cbDownwards_Option_Text"],"disable"));
					getglobal(cbBottomUpwards:GetName() .. 'Text'):SetText(ColorPrint(L["cbUpwards_Option_Text"],"disable"));
				end
				SaveOptions();
				SendSortOptionToSortBy();
				Debug("checkBoxEvent", "", 1);
			else
				ChangesComboBoxes(true);
				if ( chatMessagesOn == true ) then
					print(ColorPrint(L["in_combat_options"], "option"));
				end
			end
		end);
	cBBottom:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self,"ANCHOR_RIGHT");
			GameTooltip:AddLine(L["cBBottom_ToolTip_text"], nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	cBBottom:SetScript("OnLeave", function(self) GameTooltip:Hide() end)	
	--Combobox Bottom
	
	cbTopDownwards:SetScript("OnClick",
		function()
			if ( inCombat == false ) then
				showChatMessage = true;
				if ( cbTopDownwards:GetChecked() == true ) then
					GroupTopDownwards = true;
					GroupTopUpwards = false;
					cbTopUpwards:SetChecked(false);
				elseif ( cbTopDownwards:GetChecked() == false ) then	
					GroupTopDownwards = false;
				end
				SendSortOptionToSortBy();
				SaveOptions();
				Debug("checkBoxEvent", "", 1);
			else
				ChangesComboBoxes(true);
				if ( chatMessagesOn == true ) then
					print(ColorPrint(L["in_combat_options"], "option"));
				end
			end
		end);		
	cbTopDownwards:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self,"ANCHOR_RIGHT");
			GameTooltip:AddLine(L["cbDownwards_ToolTip_Text"], nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	cbTopDownwards:SetScript("OnLeave", function(self) GameTooltip:Hide() end)	
	--Combobox cbTopDownwards
	
	cbTopUpwards:SetScript("OnClick",
		function()
			if ( inCombat == false ) then
				showChatMessage = true;
				if ( cbTopUpwards:GetChecked() == true ) then
					GroupTopDownwards = false;
					GroupTopUpwards = true;
					cbTopDownwards:SetChecked(false);
				elseif ( cbTopUpwards:GetChecked() == false ) then	
					GroupTopUpwards = false;
				end
				SendSortOptionToSortBy();
				SaveOptions();
				Debug("checkBoxEvent", "", 1);
			else
				ChangesComboBoxes(true);
				if ( chatMessagesOn == true ) then
					print(ColorPrint(L["in_combat_options"], "option"));
				end
			end
		end);		
	cbTopUpwards:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self,"ANCHOR_RIGHT");
			GameTooltip:AddLine(L["cbUpwards_ToolTip_Text"], nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	cbTopUpwards:SetScript("OnLeave", function(self) GameTooltip:Hide() end)	
	--Combobox cbTopDownwards
	
	cbBottomDownwards:SetScript("OnClick",
		function()
			if ( inCombat == false ) then
				showChatMessage = true;
				if ( cbBottomDownwards:GetChecked() == true ) then
					GroupBottomDownwards = true;
					GroupBottomUpwards = false;
					cbBottomUpwards:SetChecked(false);
				elseif ( cbBottomDownwards:GetChecked() == false ) then	
					GroupBottomDownwards = false;
				end
				SendSortOptionToSortBy();
				SaveOptions();
				Debug("checkBoxEvent", "", 1);
			else
				ChangesComboBoxes(true);
				if ( chatMessagesOn == true ) then
					print(ColorPrint(L["in_combat_options"], "option"));
				end
			end
		end);		
	cbBottomDownwards:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self,"ANCHOR_RIGHT");
			GameTooltip:AddLine(L["cbDownwards_ToolTip_Text"], nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	cbBottomDownwards:SetScript("OnLeave", function(self) GameTooltip:Hide() end)	
	--Combobox cbTopDownwards
	
	cbBottomUpwards:SetScript("OnClick",
		function()
			if ( inCombat == false ) then
				showChatMessage = true;
				if ( cbBottomUpwards:GetChecked() == true ) then
					GroupBottomDownwards = false;
					GroupBottomUpwards = true;
					cbBottomDownwards:SetChecked(false);
				elseif ( cbBottomUpwards:GetChecked() == false ) then	
					GroupBottomUpwards = false;
				end
				SendSortOptionToSortBy();
				SaveOptions();
				Debug("checkBoxEvent", "", 1);
			else
				ChangesComboBoxes(true);
				if ( chatMessagesOn == true ) then
					print(ColorPrint(L["in_combat_options"], "option"));
				end
			end
		end);		
	cbBottomUpwards:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self,"ANCHOR_RIGHT");
			GameTooltip:AddLine(L["cbUpwards_ToolTip_Text"], nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	cbBottomUpwards:SetScript("OnLeave", function(self) GameTooltip:Hide() end)	
	--Combobox cbTopDownwards
		
	cbAutoActivate:SetScript("OnClick",
		function()
			if ( inCombat == false ) then
				showChatMessage = true;
				if ( cbAutoActivate:GetChecked() == true ) then
					GroupAutoActivate = true;
					UIDropDownMenu_SetText(page2ddmProfiles, "");
					DisableSliders();
					if ( RaidProfilOnLoadExists(raidProfile) == true ) then
						table.remove(page2RaidProfilesOnLoad, raidProfilOnLoadIndex);
					end
				elseif ( cbAutoActivate:GetChecked() == false ) then
					GroupAutoActivate = false;
				end
				UIDropDownMenu_SetText(page2ddmProfiles, "");
				UIDropDownMenu_SetText(page2ddmSavedProfiles, "");
				DisableSliders();
				fillArray();
				SendSortOptionToSortBy();
				SaveOptions();
				Debug("checkBoxEvent", "", 1);
			else
				ChangesComboBoxes(true);
				if ( chatMessagesOn == true ) then
					print(ColorPrint(L["in_combat_options"], "option"));
				end
			end
		end);		
	cbAutoActivate:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self,"ANCHOR_RIGHT");
			GameTooltip:AddLine(L["cbAutoActivate_ToolTip_Text"], nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	cbAutoActivate:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
	--Combobox AutoActive
		
	cbRegardlessRaidProfile:SetScript("OnClick",
		function()
			if ( inCombat == false ) then
				showChatMessage = true;
				if ( cbRegardlessRaidProfile:GetChecked() == true ) then
					RegardlessRaidProfile = true;
					cacheAutoActive = AutoActivate;
					AutoActivate = false;
					UIDropDownMenu_DisableDropDown(ddmProfiles);
					cbAutoActivate:Disable();
					getglobal(cbAutoActivate:GetName() .. 'Text'):SetText(ColorPrint(L["cbAutoActivate_Option_Text"],"disable"));
					UIDropDownMenu_SetText(page2ddmProfiles, "");
					DisableSliders();
				elseif ( cbRegardlessRaidProfile:GetChecked() == false ) then
					RegardlessRaidProfile = false;
					AutoActivate = cacheAutoActive;
					cbAutoActivate:Enable();
					UIDropDownMenu_EnableDropDown(ddmProfiles);
					getglobal(cbAutoActivate:GetName() .. 'Text'):SetText(L["cbAutoActivate_Option_Text"]);
				end
				UIDropDownMenu_SetText(page2ddmProfiles, "");
				UIDropDownMenu_SetText(page2ddmSavedProfiles, "");
				DisableSliders();
				SendSortOptionToSortBy();
				SaveOptions();
				Debug("checkBoxEvent", "", 1);
			else
				ChangesComboBoxes(true);
				if ( chatMessagesOn == true ) then
					print(ColorPrint(L["in_combat_options"], "option"));
				end
			end
		end);		
	cbRegardlessRaidProfile:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self, "ANCHOR_RIGHT");
			GameTooltip:AddLine(L["cbRegardlessRaidProfile_Tooltip_Text"], nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	cbRegardlessRaidProfile:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
	--Combobox RegardlessRaidProfile
	
	cbChatMessagesOn:SetScript("OnClick",
		function()
			if ( inCombat == false ) then
				if ( cbChatMessagesOn:GetChecked() == true ) then
					chatMessagesOn = true;
					print(ColorPrint(L["chat_Messages_On"], "option"));
				elseif ( cbChatMessagesOn:GetChecked() == false ) then
					chatMessagesOn = false;
				end
				SaveOptions();
				Debug("checkBoxEvent", "", 1);
			else
				ChangesComboBoxes(true);
				if ( chatMessagesOn == true ) then
					print(ColorPrint(L["in_combat_options"], "option"));
				end
			end
		end);		
	cbChatMessagesOn:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self, "ANCHOR_RIGHT");
			GameTooltip:AddLine(L["cbChatMessagesOn_Tooltip_Text"], nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	cbChatMessagesOn:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
	--Combobox ChatMessagesOn
	
	page2cbActive:SetScript("OnClick",
		function()
			if ( inCombat == false ) then
				if ( page2cbActive:GetChecked() == true ) then
					page2Active = true;
					UIDropDownMenu_EnableDropDown(page2ddmProfiles);
					UIDropDownMenu_EnableDropDown(page2ddmSavedProfiles);
					page2btnReset:Enable();
				elseif ( page2cbActive:GetChecked() == false ) then
					page2Active = false;
					UIDropDownMenu_DisableDropDown(page2ddmProfiles);
					UIDropDownMenu_DisableDropDown(page2ddmSavedProfiles);
					UIDropDownMenu_SetText(page2ddmProfiles, "");
					UIDropDownMenu_SetText(page2ddmSavedProfiles, "");
					page2btnDelete:Disable();
					page2btnReset:Disable();
					DisableSliders();
				end
				SaveOptions();
				Debug("checkBoxEvent", "", 1);
			else
				ChangesComboBoxes(true);
				if ( chatMessagesOn == true ) then
					print(ColorPrint(L["in_combat_options"], "option"));
				end
			end
		end);		
	page2cbActive:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self, "ANCHOR_RIGHT");
			GameTooltip:AddLine(L["page2cbActive_Tooltip_Text"], nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	page2cbActive:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
	--Combobox page2Active
end
--ComboBox Events

local function buttonEvent()
	btnReload:SetScript("OnClick", 
		function()
			if ( inCombat == false ) then
				ReloadUI();
			end
		end);
		
	page2btnSave:SetScript("OnClick",
		function()
			if ( math.floor(page2SliderMinimum:GetValue()) < math.floor(page2SliderMaximum:GetValue()) ) then
				if ( page2raidProfile ~= nil and page2raidProfile ~= "" ) then
					if ( RaidProfilOnLoadExists(page2raidProfile) == false ) then
						if ( ElementIsInArray( (math.floor(page2SliderMinimum:GetValue())), (math.floor(page2SliderMaximum:GetValue())) ) == nil ) then
							number = CountTable(page2RaidProfilesOnLoad) + 1;
							page2RaidProfilesOnLoad[number] = {}
							page2RaidProfilesOnLoad[number].RaidProfileName = page2raidProfile;
							page2RaidProfilesOnLoad[number].Minimum = math.floor(page2SliderMinimum:GetValue());
							page2RaidProfilesOnLoad[number].Maximum =  math.floor(page2SliderMaximum:GetValue());
							UIDropDownMenu_SetText(page2ddmProfiles, "");
							UIDropDownMenu_SetText(page2ddmSavedProfiles, "");	
							page2btnDelete:Disable();
							page2btnSave:Disable();
							DisableSliders();
							fillArray();
							if ( chatMessagesOn == true ) then
								cache1PrintPage2btnSave = L["Saved_RaidProfile_OnLoad"]:gsub("'replacement'", page2raidProfile):gsub("'replacement2'", math.floor(page2SliderMinimum:GetValue()));
								print( ColorPrint(cache1PrintPage2btnSave:gsub("'replacement3'", math.floor(page2SliderMaximum:GetValue())), "option") );
							end
						else
							cache2PrintPage2btnSave =  ElementIsInArray( (math.floor(page2SliderMinimum:GetValue())), (math.floor(page2SliderMaximum:GetValue())) );
							print( ColorPrint(L["already_in_use"]:gsub("'replacement'", cache2PrintPage2btnSave), "option") );
						end
					else
						cache3PrintPage2btnSave =  ElementIsInArray( (math.floor(page2SliderMinimum:GetValue())), (math.floor(page2SliderMaximum:GetValue())) );
						print( ColorPrint(L["already_in_use"]:gsub("'replacement'", cache3PrintPage2btnSave), "option") );
					end
				elseif ( page2raidProfileSaved ~= nil and page2raidProfileSaved ~= "" ) then
					RaidProfilOnLoadExists(page2raidProfileSaved);
					if ( ElementChangeOwnElement( (math.floor(page2SliderMinimum:GetValue())), (math.floor(page2SliderMaximum:GetValue())), page2raidProfileSaved ) == true ) then					
						page2RaidProfilesOnLoad[raidProfilOnLoadIndex].RaidProfileName = page2raidProfileSaved;
						page2RaidProfilesOnLoad[raidProfilOnLoadIndex].Minimum = math.floor(page2SliderMinimum:GetValue());
						page2RaidProfilesOnLoad[raidProfilOnLoadIndex].Maximum =  math.floor(page2SliderMaximum:GetValue());
						UIDropDownMenu_SetText(page2ddmProfiles, "");
						page2btnSave:Disable();
						fillArray();
						if ( chatMessagesOn == true ) then
							cache4PrintPage2btnSave = L["Saved_RaidProfile_OnLoad"]:gsub("'replacement'", page2raidProfileSaved):gsub("'replacement2'", math.floor(page2SliderMinimum:GetValue()));
							print( ColorPrint(cache4PrintPage2btnSave:gsub("'replacement3'", math.floor(page2SliderMaximum:GetValue())), "option") );
						end
					else
						print( ColorPrint(L["already_in_use"]:gsub("'replacement'", page2raidProfilOnThatPlace), "option") );
					end
				end
				SaveOptions();
			else
				print( ColorPrint(L["page2btnSave_Error"]) );
			end
		end);
	
	page2btnDelete:SetScript("OnClick",
		function()
			if ( raidProfilOnLoadIndex == 0 and page2ddmSavedProfilesCounter == 1 ) then
				if ( chatMessagesOn == true ) then
					print( ColorPrint(L["Deleted_RaidProfile"]:gsub("'replacement'", page2raidProfileSaved), "option") );
				end
				page2RaidProfilesOnLoad = nil;
				page2RaidProfilesOnLoad = {};
			else
				RaidProfilOnLoadExists(page2raidProfileSaved);
				if ( chatMessagesOn == true ) then
					print( ColorPrint(L["Deleted_RaidProfile"]:gsub("'replacement'", page2raidProfileSaved), "option") );
				end
				table.remove(page2RaidProfilesOnLoad, raidProfilOnLoadIndex);
			end
			page2ddmSavedProfilesCounter = page2ddmSavedProfilesCounter -1;
			UIDropDownMenu_SetText(page2ddmSavedProfiles, "");	
			page2btnDelete:Disable();
			page2btnSave:Disable();
			DisableSliders();
			fillArray();
			SaveOptions();
		end);
		
	page2btnReset:SetScript("OnClick",
		function()
			page2RaidProfilesOnLoad = nil;
			page2RaidProfilesOnLoad = {};	
			UIDropDownMenu_SetText(page2ddmProfiles, "");
			UIDropDownMenu_SetText(page2ddmSavedProfiles, "");
			page2btnDelete:Disable();
			page2btnSave:Disable();
			DisableSliders();
			fillArray();
			SaveOptions();			
		end);
	page2btnReset:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self, "ANCHOR_RIGHT");
			GameTooltip:AddLine(L["page2btnReset_ToolTip_text"], nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	page2btnReset:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
end

local function SliderEvent()
	page2SliderMinimum:SetScript("OnValueChanged",
		function()
			if ( (page2raidProfile ~= nil and page2raidProfileSaved == nil) or  (page2raidProfile == nil and page2raidProfileSaved ~= nil) ) then				
				ColorSliders("Minimum");
				if ( page2raidProfileSaved ~= nil ) then
					RaidProfilOnLoadExists(page2raidProfileSaved);
					if ( page2RaidProfilesOnLoad[raidProfilOnLoadIndex].Minimum ==  math.floor(page2SliderMinimum:GetValue()) and page2RaidProfilesOnLoad[raidProfilOnLoadIndex].Maximum ==  math.floor(page2SliderMaximum:GetValue())) then
						page2btnSave:Disable();
					else
						page2btnSave:Enable();
					end
				end
			end
		end);
		
	page2SliderMaximum:SetScript("OnValueChanged",
		function()
			if ( (page2raidProfile ~= nil and page2raidProfileSaved == nil) or  (page2raidProfile == nil and page2raidProfileSaved ~= nil) ) then
				ColorSliders("Maximum");
				if ( page2raidProfileSaved ~= nil ) then
					RaidProfilOnLoadExists(page2raidProfileSaved);
					if ( page2RaidProfilesOnLoad[raidProfilOnLoadIndex].Minimum ==  math.floor(page2SliderMinimum:GetValue()) and page2RaidProfilesOnLoad[raidProfilOnLoadIndex].Maximum ==  math.floor(page2SliderMaximum:GetValue())) then
						page2btnSave:Disable();
					else
						page2btnSave:Enable();
					end
				end
			end	
		end);
end
---End Events



function SortTopDownwards()
	Debug("SortTopDownwards", "", 2);
	LoadAddOn("Blizzard_CompactRaidFrames");
	CRFSort_TopDownwards = function(t1, t2)
		if UnitIsUnit(t1, "player") then 
			return true;
		elseif UnitIsUnit(t2, "player") then 
			return false;
		else 
			return t1 < t2;
		end 
	end
	CompactRaidFrameContainer_SetFlowSortFunction(manager.container,CRFSort_TopDownwards)
end

function SortTopUpwards()
	Debug("SortTopUpwards", "", 2);
	LoadAddOn("Blizzard_CompactRaidFrames");
	CRFSort_TopUpwards = function(t1, t2)
		if UnitIsUnit(t1, "player") then 
			return true;
		elseif UnitIsUnit(t2, "player") then 
			return false;
		else 
			return t1 > t2;
		end 
	end
	CompactRaidFrameContainer_SetFlowSortFunction(manager.container,CRFSort_TopUpwards)
end
	
function SortBottomUpwards()
	Debug("SortBottomUpwards", "", 2);
	LoadAddOn("Blizzard_CompactRaidFrames");
	CRFSort_BottomUpwards = function(t1, t2)
		if UnitIsUnit(t1, "player") then 
			return false;
		elseif UnitIsUnit(t2, "player") then 
			return true; 
		else 
			return t1 > t2;
		end 
	end
	CompactRaidFrameContainer_SetFlowSortFunction(manager.container,CRFSort_BottomUpwards)
end

function SortBottomDownwards()
	Debug("SortBottomDownwards", "", 2);
	LoadAddOn("Blizzard_CompactRaidFrames");
	CRFSort_BottomDownwards = function(t1, t2)
		if UnitIsUnit(t1, "player") then 
			return false;
		elseif UnitIsUnit(t2, "player") then 
			return true; 
		else 
			return t1 < t2;
		end 
	end
	CompactRaidFrameContainer_SetFlowSortFunction(manager.container,CRFSort_BottomDownwards)
end

function SendSortOptionToSortBy()
	Debug("SendSortOptionToSortBy", "", 2);
	if ( RegardlessRaidProfile == false ) then
		if ( GroupTop == true or GroupBottom == true ) then
			if ( ReadAllRaidProfiles(raidProfile) == false ) then
				cachePrintSendSortOptionToSortBy = L["RaidProfil_dont_exists"]:gsub("'replacement'", raidProfile);
				raidProfile = GetRaidProfileName(1);
				if ( chatMessagesOn == true ) then
					print(ColorPrint(cachePrintSendSortOptionToSortBy:gsub("'replacement2'", raidProfile), "option"));
				end
				UIDropDownMenu_SetText(ddmProfiles, raidProfile);
			end
		end
	end
	if ( GroupTop == true ) then
		SortBy('Down', raidProfile);
	elseif ( GroupBottom == true ) then
		SortBy('Up', raidProfile);
	else
		if ( showChatMessage == true ) then
			if ( chatMessagesOn == true ) then
				print (ColorPrint(L["sort_no"], "option"));
			end	
		end
	end
	if ( showChatMessage == true ) then
		showChatMessage = false;
	end
end
-- Breakpoint between Methods and SortBy

function SortBy(SortOption, RaidProfileName)	
	Debug("SortBy", "", 2);
	if ( inCombat == false ) then
		if ( RaidProfileName ~= nil and GetNumGroupMembers() <= 5 and HasLoadedCUFProfiles() == true ) then
			if ( GroupAutoActivate == true or page2Active == true ) then
				SwitchRaidProfiles();
			end
			if ( GetActiveRaidProfile() ~= RaidProfileName and GroupAutoActivate == false and RegardlessRaidProfile == false ) then
				if ( showChatMessage == true ) then
					if ( chatMessagesOn == true ) then
						print(ColorPrint(L["RaidProfil_Doesnt_match"], "option"));
					end
				end
			elseif ( GetActiveRaidProfile() == RaidProfileName or RegardlessRaidProfile == true ) then
				if ( SortOption == 'Down') then
					if ( GroupTopDownwards == true ) then
						if ( showChatMessage == true ) then
							if ( RegardlessRaidProfile == true ) then
								if ( chatMessagesOn == true ) then
									print(ColorPrint(L["sort_top_downwards_regardless"], "option"));
								end
							else
								if ( chatMessagesOn == true ) then
									print(ColorPrint(L["sort_top_downwards"]:gsub("'replacement'", RaidProfileName), "option"));
								end
							end
						end
						CheckRaidProfileOptions();
						SortTopDownwards();
					end
					if ( GroupTopUpwards == true ) then
						if ( showChatMessage == true ) then
							if ( RegardlessRaidProfile == true ) then
								if ( chatMessagesOn == true ) then
									print(ColorPrint(L["sort_top_upwards_regardless"], "option"));
								end
							else
								if ( chatMessagesOn == true ) then
									print(ColorPrint(L["sort_top_upwards"]:gsub("'replacement'", RaidProfileName), "option"));
								end
							end
						end
						CheckRaidProfileOptions();
						SortTopUpwards();
					end
				elseif ( SortOption == 'Up') then
					if ( GroupBottomDownwards == true ) then
						if ( showChatMessage == true ) then
							if ( RegardlessRaidProfile == true ) then
								if ( chatMessagesOn == true ) then
									print(ColorPrint(L["sort_bottom_downwards_regardless"], "option"));
								end
							else
								if ( chatMessagesOn == true ) then
									print(ColorPrint(L["sort_bottom_downwards"]:gsub("'replacement'", RaidProfileName), "option"));
								end
							end
						end
						CheckRaidProfileOptions();
						SortBottomDownwards();
					end
					if ( GroupBottomUpwards == true ) then
						if ( showChatMessage == true ) then
							if ( RegardlessRaidProfile == true ) then
								if ( chatMessagesOn == true ) then
									print(ColorPrint(L["sort_bottom_upwards_regardless"], "option"));
								end
							else
								if ( chatMessagesOn == true ) then
									print(ColorPrint(L["sort_bottom_upwards"]:gsub("'replacement'", RaidProfileName), "option"));
								end
							end
						end
						CheckRaidProfileOptions();
						SortBottomUpwards();
					end
				end
			end		
		end
	end
end
-- Final desicion, which Raid Profile gets loaded and which Sort Method will be used

function InGroupText()
	Debug("InGroupText", "", 2);
	if ( GetNumGroupMembers() > 1 ) then
		Debug("InGroupText", true, 3);
		return true;
	end
	Debug("InGroupText", false, 3);
	return false;
end

function CheckRaidProfileOptions()
	Debug("CheckRaidProfileOptions", "RaidStylePartyFrames clicked", 2);
	if ( CompactUnitFrameProfilesRaidStylePartyFrames:GetChecked() == false ) then
		CompactUnitFrameProfilesRaidStylePartyFrames:Click(true);
		Debug("CheckRaidProfileOptions", "RaidStylePartyFrames clicked", 3);
	end
	if ( CompactUnitFrameProfilesGeneralOptionsFrameKeepGroupsTogether:GetChecked() == true ) then
		CompactUnitFrameProfilesGeneralOptionsFrameKeepGroupsTogether:Click(true);	
		Debug("CheckRaidProfileOptions", "KeepGroupsTogether clicked", 3);
	end
end
--necessary changes, otherwise there is no sort

function ReadAllRaidProfiles(raidProfile)
	raidprofilexists = false;
	ddmItems = nil;
	ddmItems = {};
	for i=1, GetNumRaidProfiles(), 1 do
		ddmItems[i] = GetRaidProfileName(i);
		if ( ddmItems[i] == raidProfile ) then
			raidprofilexists = true;
			
		end
	end
	if ( raidprofilexists == true ) then
		Debug("ReadAllRaidProfiles", raidProfile .. " exists", 3);
		return true;
	end
	return false;
end
--Fills ddmItems with raidprofiles and checks if raidprofil exists

function ChangesComboBoxes()
	Debug("ChangesComboBoxes", "", 2);
	if ( GroupAutoActivate == true ) then
		cbAutoActivate:SetChecked(true);
	else
		cbAutoActivate:SetChecked(false);
	end
	
	if ( RegardlessRaidProfile == true ) then
		cacheAutoActive = AutoActivate;
		AutoActivate = false;
		UIDropDownMenu_DisableDropDown(ddmProfiles);
		cbAutoActivate:Disable();
		getglobal(cbAutoActivate:GetName() .. 'Text'):SetText(ColorPrint(L["cbAutoActivate_Option_Text"],"disable"));
		cbRegardlessRaidProfile:SetChecked(true);
	else
		RegardlessRaidProfile = false;
		AutoActivate = cacheAutoActive;
		cbAutoActivate:Enable();
		if ( cbAutoActivate:GetChecked() == true ) then
			UIDropDownMenu_EnableDropDown(ddmProfiles);
		end
		cbRegardlessRaidProfile:SetChecked(false);
	end
	
	if ( GroupTop == true ) then
		cBTop:SetChecked(true);
		cBBottom:SetChecked(false);
		cbTopDownwards:Enable();
		cbTopUpwards:Enable();
		cbBottomDownwards:Disable();
		cbBottomUpwards:Disable();
		getglobal(cbTopDownwards:GetName() .. 'Text'):SetText(L["cbDownwards_Option_Text"]);
		getglobal(cbTopUpwards:GetName() .. 'Text'):SetText(L["cbUpwards_Option_Text"]);
		getglobal(cbBottomDownwards:GetName() .. 'Text'):SetText(ColorPrint(L["cbDownwards_Option_Text"],"disable"));
		getglobal(cbBottomUpwards:GetName() .. 'Text'):SetText(ColorPrint(L["cbUpwards_Option_Text"],"disable"));
	elseif ( GroupBottom == true ) then
		cBTop:SetChecked(false);
		cBBottom:SetChecked(true);
		cbTopDownwards:Disable();
		cbTopUpwards:Disable();
		cbBottomDownwards:Enable();
		cbBottomUpwards:Enable();
		getglobal(cbTopDownwards:GetName() .. 'Text'):SetText(ColorPrint(L["cbDownwards_Option_Text"],"disable"));
		getglobal(cbTopUpwards:GetName() .. 'Text'):SetText(ColorPrint(L["cbUpwards_Option_Text"],"disable"));
		getglobal(cbBottomDownwards:GetName() .. 'Text'):SetText(L["cbDownwards_Option_Text"]);
		getglobal(cbBottomUpwards:GetName() .. 'Text'):SetText(L["cbUpwards_Option_Text"]);
	else
		cBTop:SetChecked(false);
		cBBottom:SetChecked(false);
		cbTopDownwards:Disable();
		cbTopUpwards:Disable();
		cbBottomDownwards:Disable();
		cbBottomUpwards:Disable();
		getglobal(cbTopDownwards:GetName() .. 'Text'):SetText(ColorPrint(L["cbDownwards_Option_Text"],"disable"));
		getglobal(cbTopUpwards:GetName() .. 'Text'):SetText(ColorPrint(L["cbUpwards_Option_Text"],"disable"));
		getglobal(cbBottomDownwards:GetName() .. 'Text'):SetText(ColorPrint(L["cbDownwards_Option_Text"],"disable"));
		getglobal(cbBottomUpwards:GetName() .. 'Text'):SetText(ColorPrint(L["cbUpwards_Option_Text"],"disable"));
	end
	
	if ( GroupTopDownwards == true ) then
		cbTopDownwards:SetChecked(true);
		cbTopUpwards:SetChecked(false);
	elseif ( GroupTopUpwards == true ) then
			cbTopDownwards:SetChecked(false);
			cbTopUpwards:SetChecked(true);
	else 	
		cbTopDownwards:SetChecked(false);
		cbTopUpwards:SetChecked(false);
	end
	if ( GroupBottomDownwards == true ) then
		cbBottomDownwards:SetChecked(true);
		cbBottomUpwards:SetChecked(false);
	elseif ( GroupBottomUpwards == true ) then
		cbBottomDownwards:SetChecked(false);
		cbBottomUpwards:SetChecked(true);
	else
		cbBottomDownwards:SetChecked(false);
		cbBottomUpwards:SetChecked(false);
	end
	
	if ( chatMessagesOn == true ) then
		cbChatMessagesOn:SetChecked(true);
	else 
		cbChatMessagesOn:SetChecked(false);
	end
	
	if ( page2Active == true ) then
		page2cbActive:SetChecked(true);
		UIDropDownMenu_EnableDropDown(page2ddmProfiles);
	else
		UIDropDownMenu_SetText(page2ddmProfiles, "");
		page2cbActive:SetChecked(false);
		UIDropDownMenu_DisableDropDown(page2ddmProfiles);
		DisableSliders();
	end
	if ( page2raidProfile == nil ) then
		DisableSliders();
	end
end
--In combat no changes

function DisableSliders()
	Debug("DisableSliders", "", 2);
	page2SliderMinimum:Disable();
	page2SliderMaximum:Disable();
	page2btnSave:Disable();
	page2btnDelete:Disable();
	getglobal(page2SliderMinimum:GetName() .. 'Low'):SetText(ColorPrint('2', "disable"));
	getglobal(page2SliderMinimum:GetName() .. 'High'):SetText(ColorPrint('40', "disable"));
	getglobal(page2SliderMinimum:GetName() .. 'Text'):SetText(ColorPrint(math.floor(page2SliderMinimum:GetValue()), "disable"));
	getglobal(page2SliderMaximum:GetName() .. 'Low'):SetText(ColorPrint('2', "disable"));
	getglobal(page2SliderMaximum:GetName() .. 'High'):SetText(ColorPrint('40', "disable"))
	getglobal(page2SliderMaximum:GetName() .. 'Text'):SetText(ColorPrint(math.floor(page2SliderMaximum:GetValue()), "disable"));
end

function ColorSliders(option,index)
	Debug("ColorSliders", "", 2);
	cacheProfileColorSliders = nil
	if ( page2raidProfileSaved ~= nil ) then
		cacheProfileColorSliders = page2raidProfileSaved;
	else
		cacheProfileColorSliders = page2raidProfile;
	end
	if ( option == "Minimum" ) then
		if ( ( math.floor(page2SliderMinimum:GetValue()) ) < ( math.floor(page2SliderMaximum:GetValue()) ) ) then
			if ( MinMaxInArray(math.floor(page2SliderMinimum:GetValue())) == false ) then
				getglobal(page2SliderMinimum:GetName() .. 'Text'):SetText( ColorPrint((math.floor(page2SliderMinimum:GetValue())), "green" ));
			elseif ( ElementChangeOwnElement( (math.floor(page2SliderMinimum:GetValue())), (math.floor(page2SliderMaximum:GetValue())), cacheProfileColorSliders ) == true ) then
				getglobal(page2SliderMinimum:GetName() .. 'Text'):SetText( ColorPrint((math.floor(page2SliderMinimum:GetValue())), "green" ));
			else
				getglobal(page2SliderMinimum:GetName() .. 'Text'):SetText( ColorPrint((math.floor(page2SliderMinimum:GetValue())), "red" ));
			end
		else
			page2SliderMinimum:SetValue(math.floor(page2SliderMaximum:GetValue()) -1 );
			if ( MinMaxInArray(math.floor(page2SliderMinimum:GetValue())) == false ) then
				getglobal(page2SliderMinimum:GetName() .. 'Text'):SetText( ColorPrint((math.floor(page2SliderMinimum:GetValue())  ), "green" ));
			elseif ( ElementChangeOwnElement( (math.floor(page2SliderMinimum:GetValue())), (math.floor(page2SliderMaximum:GetValue())), cacheProfileColorSliders ) == true ) then				
				getglobal(page2SliderMinimum:GetName() .. 'Text'):SetText( ColorPrint((math.floor(page2SliderMinimum:GetValue()) ), "green" ));
			else
				getglobal(page2SliderMinimum:GetName() .. 'Text'):SetText( ColorPrint((math.floor(page2SliderMinimum:GetValue())  ), "red" ));
			end
		end
	elseif ( option == "Maximum" ) then
		if ( ( math.floor(page2SliderMaximum:GetValue()) ) > ( math.floor(page2SliderMinimum:GetValue()) ) ) then
			if ( MinMaxInArray(math.floor(page2SliderMaximum:GetValue())) == false ) then
				getglobal(page2SliderMaximum:GetName() .. 'Text'):SetText( ColorPrint((math.floor(page2SliderMaximum:GetValue())), "green" ));
			elseif ( ElementChangeOwnElement( (math.floor(page2SliderMaximum:GetValue())), (math.floor(page2SliderMaximum:GetValue())), cacheProfileColorSliders ) == true ) then
				getglobal(page2SliderMaximum:GetName() .. 'Text'):SetText( ColorPrint((math.floor(page2SliderMaximum:GetValue())), "green" ));
			else
				getglobal(page2SliderMaximum:GetName() .. 'Text'):SetText( ColorPrint((math.floor(page2SliderMaximum:GetValue())), "red" ));
			end
		else
			page2SliderMaximum:SetValue(math.floor(page2SliderMinimum:GetValue()) +1 );
			if ( MinMaxInArray(math.floor(page2SliderMaximum:GetValue())) == false ) then
				getglobal(page2SliderMaximum:GetName() .. 'Text'):SetText( ColorPrint((math.floor(page2SliderMaximum:GetValue()) ), "green" ));
			elseif ( ElementChangeOwnElement( (math.floor(page2SliderMinimum:GetValue())), (math.floor(page2SliderMaximum:GetValue())), cacheProfileColorSliders ) == true ) then
				getglobal(page2SliderMaximum:GetName() .. 'Text'):SetText( ColorPrint((math.floor(page2SliderMaximum:GetValue()) ), "green" ));
			else
				getglobal(page2SliderMaximum:GetName() .. 'Text'):SetText( ColorPrint((math.floor(page2SliderMaximum:GetValue()) ), "red" ));
			end
		end
	elseif ( option == "ddmProfiles" ) then
		if ( MinMaxInArray(math.floor(page2SliderMinimum:GetValue())) == false ) then
			getglobal(page2SliderMinimum:GetName() .. 'Text'):SetText( ColorPrint((math.floor(page2SliderMinimum:GetValue())), "green" ));
		else
			getglobal(page2SliderMinimum:GetName() .. 'Text'):SetText( ColorPrint((math.floor(page2SliderMinimum:GetValue())), "red" ));
		end
		if ( MinMaxInArray(math.floor(page2SliderMaximum:GetValue())) == false ) then
			getglobal(page2SliderMaximum:GetName() .. 'Text'):SetText( ColorPrint((math.floor(page2SliderMaximum:GetValue())), "green" ));
		else
			getglobal(page2SliderMaximum:GetName() .. 'Text'):SetText( ColorPrint((math.floor(page2SliderMaximum:GetValue())), "red" ));
		end
	elseif ( option == "ddmSelectedProfiles" ) then
		page2SliderMinimum_Text:SetValue( page2RaidProfilesOnLoad[index].Minimum );
		page2SliderMaximum_Text:SetValue( page2RaidProfilesOnLoad[index].Maximum );
		getglobal(page2SliderMinimum:GetName() .. 'Text'):SetText( ColorPrint(page2RaidProfilesOnLoad[index].Minimum, "green" ));
		getglobal(page2SliderMaximum:GetName() .. 'Text'):SetText( ColorPrint(page2RaidProfilesOnLoad[index].Maximum, "green" ));
	end
end
-- Method to only coler sliders
	
function resetRaidContainer()	
	Debug("resetRaidContainer", "", 2);
	local old_CompactRaidFrameContainer_TryUpdate = CompactRaidFrameContainer_TryUpdate
	CompactRaidFrameContainer_TryUpdate = function(self)	
		if ( inCombat == true ) then
			CompactSave[self:GetName()] = "CompactRaidFrameContainer_TryUpdate"
		else
			old_CompactRaidFrameContainer_TryUpdate(self)
		end
	end

	local old_CompactRaidGroup_UpdateUnits = CompactRaidGroup_UpdateUnits
	CompactRaidGroup_UpdateUnits = function(self)
		if ( inCombat == true ) then
			CompactSave[self:GetName()] = "CompactRaidGroup_UpdateUnits"
		else
			old_CompactRaidGroup_UpdateUnits(self)
		end
	end
end

function SortGroupIsActive()
	Debug("SortGroupIsActive", "", 2);
	if ( GetNumGroupMembers() <= 5 and ( (GroupTop == true and GroupTopDownwards == true) or (GroupTop == true and GroupTopUpwards == true) or (GroupBottom == true and GroupBottomDownwards == true) or (GrouUp == true and GroupBottomUpwards == true) ) ) then
		Debug("SortGroupIsActive", true, 3);
		return true;
	end
	Debug("SortGroupIsActive", false, 3);
	return false;
end

function ColorPrint(text, operation)
	if ( operation == "option" ) then
		cacheText = text:gsub("SortGroup:" , function(cap)
			cap = cap:sub(1, -1);
			local color = "|cff00FF7F" or defaultColor;
			return color..cap.."|r";
		end)
		return cacheText;
	elseif ( operation == "disable" ) then
		local color = "|cff888888" or defaultColor;
		return color..text;
	elseif ( operation == "green" ) then
		local color = "|cff00ff00" or defaultColor;
		return color..text;
	elseif ( operation == "red" ) then
		local color = "|cffff0000" or defaultColor;
		return color..text;
	end
end
-- Color everything expcept sliders

function CountTable(t)
	Debug("CountTable", "", 2);
	local count = 0
	for _ in pairs(t) do count = count + 1 end
	return count;
end

function RaidProfilOnLoadExists(raidProfilOnLoad)
	Debug("RaidProfilOnLoadExists", nil, 2);
	if ( CountTable(page2RaidProfilesOnLoad) > 0 ) then
		for i = 1, (CountTable(page2RaidProfilesOnLoad)), 1 do
			if ( page2RaidProfilesOnLoad[i] ~= nil ) then
				if ( page2RaidProfilesOnLoad[i].RaidProfileName == raidProfilOnLoad ) then
					raidProfilOnLoadIndex = i;
					Debug("RaidProfilOnLoadExists", true);
					return true;
				end
			else
				Debug("RaidProfilOnLoadExists", nil, 3);
			end
		end
	end
	return false;
end
--  Checks if RaidProfil is in List

function DeleteRaidProfileNotExists()
	Debug("DeleteRaidProfileNotExists", "", 2);
	if ( CountTable(page2RaidProfilesOnLoad) > 0 ) then
		for i = 1, (CountTable(page2RaidProfilesOnLoad)), 1 do
			if ( page2RaidProfilesOnLoad[i] ~= nil ) then
				if ( ReadAllRaidProfiles(page2RaidProfilesOnLoad[i].RaidProfileName) == false ) then
					if ( chatMessagesOn == true ) then
						print( ColorPrint(L["Deleted_RaidProfile_Not_Exists"]:gsub("'replacement'", (page2RaidProfilesOnLoad[i].RaidProfileName)), "option") );
					end
					Debug("DeleteRaidProfileNotExists", (page2RaidProfilesOnLoad[i].RaidProfileName .. " deleted"), 3 );
					table.remove(page2RaidProfilesOnLoad, i);	
					page2btnDelete:Disable();
					page2btnSave:Disable();
					DisableSliders();
				end
			end
		end
	end
	fillArray();
end
-- Raid Profiles that not exists anymore get deleted

function SwitchRaidProfiles()
	Debug("SwitchRaidProfiles", "", 2);
	if ( inCombat == false ) then
		DeleteRaidProfileNotExists();
		member = tonumber(GetNumGroupMembers());
		if ( HasLoadedCUFProfiles() == true and GetNumGroupMembers() > 0 ) then
			if ( page2Array[member][0] == true and page2Array[member][1] ~= "" ) then
				if ( GetActiveRaidProfile() ~= page2Array[member][1] and page2Active == true ) then
					CompactUnitFrameProfiles_ActivateRaidProfile(page2Array[member][1]);	
					if ( chatMessagesOn == true ) then
						print( ColorPrint(L["RaidProfil_changed"]:gsub("'replacement'", (page2Array[member][1])), "option") );
					end
					Debug("SwitchRaidProfiles", "member > 0, page2Active = true", 3);
				elseif ( GetActiveRaidProfile() ~= page2Array[member][1] and page2Active == false ) then
					if ( page2Array[1][0] == true and page2Array[1][1] ~= "" ) then
						if ( GetActiveRaidProfile() ~= page2Array[1][1] ) then
							CompactUnitFrameProfiles_ActivateRaidProfile(page2Array[1][1]);
						if ( chatMessagesOn == true ) then
							print( ColorPrint(L["RaidProfil_changed"]:gsub("'replacement'", (page2Array[1][1])), "option") );
						end
					Debug("SwitchRaidProfiles", "member > 0, page2Active = false", 3);
				end
			end
				end
			end		
		elseif ( HasLoadedCUFProfiles() == true and member == 0 ) then
			if ( page2Array[1][0] == true and page2Array[1][1] ~= "" ) then
				if ( GetActiveRaidProfile() ~= page2Array[1][1] ) then
					CompactUnitFrameProfiles_ActivateRaidProfile(page2Array[1][1]);
					if ( chatMessagesOn == true ) then
						print( ColorPrint(L["RaidProfil_changed"]:gsub("'replacement'", (page2Array[1][1])), "option") );
					end
					Debug("SwitchRaidProfiles", "member = 0", 3);
				end
			end
		end
	end
end
-- Switch by Group_Roster

function fillArray()
	Debug("fillArray", "", 2);
	for i = 1, 40, 1 do
		page2Array[i] = {};
		if ( GroupAutoActivate == true and i <= 5 ) then
			page2Array[i][0] = true;
			page2Array[i][1] = raidProfile;
		else
			page2Array[i][0] = false;
			page2Array[i][1] = "";
		end
	end
	if ( CountTable(page2RaidProfilesOnLoad) > 0 ) then
		for i = 1, (CountTable(page2RaidProfilesOnLoad)), 1 do
			for c = (tonumber(page2RaidProfilesOnLoad[i].Minimum)), (tonumber(page2RaidProfilesOnLoad[i].Maximum)), 1 do
				if ( (GroupAutoActivate == true and c > 5) or GroupAutoActivate == false ) then
					if ( page2Array[c] ~= nil ) then
						page2Array[c][0] = true;
						page2Array[c][1] = page2RaidProfilesOnLoad[i].RaidProfileName;
					elseif ( page2Array[c] == nil ) then
						Debug("fillArray", nil, 3);
					end
					if ( page2Array[c][0] == true ) then
						Debug("fillArray", ("Index " .. c .. " true"), 3);
					else
						Debug("fillArray", ("Index " .. c .. " false"), 3);
					end
				elseif ( GroupAutoActivate == true and c <= 5 ) then
					page2Array[c][0] = true;
					page2Array[c][1] = raidProfile;
					if ( page2RaidProfilesOnLoad[i].Minimum <= 5 ) then
					Debug("fillArray", ("RaidProfil: " .. page2RaidProfilesOnLoad[i].RaidProfileName .. " Minimum: " .. page2RaidProfilesOnLoad[i].Minimum .. " deleted"), 3);
						page2RaidProfilesOnLoad[i].Minimum = 6;
					end
					if ( page2RaidProfilesOnLoad[i].Maximum <= 6 ) then
						Debug("fillArray", ("RaidProfil: " .. page2RaidProfilesOnLoad[i].RaidProfileName .. "Maximum: " .. page2RaidProfilesOnLoad[i].Maximum .. " deleted"), 3);
						page2RaidProfilesOnLoad[i].Maximum = 7; 
					end
				end
			end
		end
	end
end
-- Update Array with updated RaidProfil List

function ElementIsInArray(Minimum, Maximum)
	Debug("ElementIsInArray","", 2)
	for i = (tonumber(Minimum)), (tonumber(Maximum)), 1 do
		if ( page2Array[i] ~= nil ) then	
			if ( page2Array[i][0] == true ) then
				Debug("ElementIsInArray", ("Index " .. i .. " page2Array[i][1]"));
				return page2Array[i][1];
			end
		else
			Debug("ElementIsInArray",nil, 3)
		end
	end
	return nil;
end
-- Checks if no Raid Profils are in a specific Group Size

function MinMaxInArray(MinMax)
	Debug("MinMaxInArray", "", 2);
	if ( page2Array[MinMax] ~= nil ) then
		if ( page2Array[MinMax][0] == true ) then
			Debug("MinMaxInArray", true, 3);
			return true;
		else
			Debug("MinMaxInArray", false, 3);
			return false;
		end
	end
end
--Minimum Maximum check, true if exists

function ElementChangeOwnElement(Minimum, Maximum, raidProfilOnLoad)
	Debug("ElementChangeOwnElement", "", 2)
	OwnElement = true;
	for i = (tonumber(Minimum)), (tonumber(Maximum)), 1 do
		if ( page2Array[i] ~= nil ) then
			if ( page2Array[i][0] == true ) then
				if ( page2Array[i][1] ~= raidProfilOnLoad ) then
					page2raidProfilOnThatPlace = page2Array[i][1];
					OwnElement = false;
				end
			end
		else
			OwnElement = nil;
		end
	end
	Debug("ElementChangeOwnElement", OwnElement, 3)
	return OwnElement;
end
-- true if Raid Profil change only itselfs options


function SaveOptions()
	Debug("SaveOptions", "");
	SortGroupInformation.Down = GroupTop;
	SortGroupInformation.Up = GroupBottom;
	SortGroupInformation.TopDownwards = GroupTopDownwards;
	SortGroupInformation.TopUpwards	= GroupTopUpwards;
	SortGroupInformation.BottomDownwards = GroupBottomDownwards;
	SortGroupInformation.BottomUpwards = GroupBottomUpwards;
	SortGroupInformation.Profile = raidProfile;
	SortGroupInformation.AutoActivate = GroupAutoActivate;
	SortGroupInformation.RegardlessRaidProfile = RegardlessRaidProfile;
	SortGroupInformation.chatMessagesOn = chatMessagesOn;
	SortGroupInformation.page2Active = page2Active;
	SortGroupInformation.RaidProfileOnLoad = page2RaidProfilesOnLoad;
end
-- If client crashes, still all saved

function Debug(methodName, methodContent, methodLevel)
	if ( debugmode == true ) then
	debugLevelCache = debuglevel;
		if ( debugLevelCache % 2 == 1 and methodLevel >= 1 ) then
			debugLevelCache = debugLevelCache - 1;
			if ( methodLevel == 1 ) then
				print(ColorPrint("SortGroup: Debuging - Options", "option"));
				print("'GroupTop' " .. tostring(GroupTop));
				print("'GroupTopDownwards' " .. tostring(GroupTopDownwards));
				print("'GroupTopUpwards' " .. tostring(GroupTopUpwards));
				print("'GroupBottom' " .. tostring(GroupBottom));
				print("'GroupBottomDownwards' " .. tostring(GroupBottomDownwards));
				print("'GroupBottomUpwards' " .. tostring(GroupBottomUpwards));
			end
		end
		if ( ( debugLevelCache == 2 or debugLevelCache == 6 ) and methodLevel >= 2 ) then
			if ( debugMethodNameCache ~= methodName ) then
				print(ColorPrint("SortGroup: Debuging - Method Names", "option"));
				print("'" ..  methodName .. "()'");
				debugMethodNameCache = methodName;
			end
		end
		if ( debugLevelCache >= 4 and methodLevel == 3 ) then
			if ( debugMethodContentCache ~= methodName ) then
				print(ColorPrint("SortGroup: Debuging - Method content", "option"));	
			end
			debugMethodContentCache = methodName;
			print( "'" .. methodName .. "'() " .. tostring(methodContent));
		end		
	end
end
-- Debug, goes through everything

local function StartAddon()
	createFrame();
	createText();
	createCheckbox();
	createButton();
	createDropDownMenu();
	createSliders();
	frameEvent();	
	checkBoxEvent();
	buttonEvent();
	SliderEvent();
	resetRaidContainer();
end
StartAddon();